﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.IO.Compression;
using tar_cs;

namespace WinTar
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void BtnEstrai_Click(object sender, EventArgs e)
        {
            if (DecomprimiFileCompresso(@"C:\CartellaFile\") == true)
            {
                MessageBox.Show("File estratti con successo.");

            }
            else
            {
                MessageBox.Show("Impossibile estrare i file");
            
            
            }
        }

        private static bool DecomprimiFileCompresso(string PercorsoFile)
        {
            bool Esito = false;
            try
            {


                //eseguo la prima estrapolazione del file .gz nella stessa cartella dove si trovano i file .gz
                DirectoryInfo DiPercorsoFileGz = new DirectoryInfo(PercorsoFile);

                
                foreach (FileInfo fi in DiPercorsoFileGz.GetFiles("*.gz"))
                {
                    DecomprimiFileGz(fi);
                }
                //Decomprimo tutti i file *.tar
                Esito = DecomprimiFileTar(PercorsoFile);

            }
            catch (Exception ex)
            {
                
                throw ex;
            }
            return Esito;
        }

        private static bool DecomprimiFileTar(string PercorsoFile)
        {
            bool Esisto = false;
            try
            {
                DirectoryInfo di = new DirectoryInfo(PercorsoFile);

                //Decomprimo tutti i file di tipo *.tar 
                foreach (FileInfo fi in di.GetFiles("*.tar"))
                {
                    string PercorsoFileDecompresso = "";
                    string PathCartellaFile = "";
                    using (FileStream unarchFile = File.OpenRead(fi.FullName))
                    {


                        TarReader reader = new TarReader(unarchFile);

                        while (reader.MoveNext(true))
                        {
                            var path = reader.FileInfo.FileName;
                            if (reader.FileInfo.EntryType == EntryType.Directory)
                            {
                                //Essendo una cartella verifico se è quella che interessa (percorso superiore)
                                if (PercorsoFile.Contains(Path.GetDirectoryName(path)) == true)
                                {
                                    //creo la cartella ed estrapolo i dati
                                    PercorsoFileDecompresso = Path.Combine(PercorsoFile, Path.GetDirectoryName(path));
                                    Directory.CreateDirectory(PercorsoFileDecompresso);
                                     
                                    PathCartellaFile = Path.GetDirectoryName(path);
                                }
                            }
                            else
                            {
                                //Elaboro solo se nella variabile path (nome file) è presente la cartella da cui devo estrapolare i dati.
                                if (path.Contains("MioFile") & PathCartellaFile.Trim().Length > 1)
                                {
                                    //verifico che sia superiore a 3000 byte ossia 2 kb
                                    if (reader.FileInfo.SizeInBytes >= 3000)
                                    {
                                        path = Path.Combine(PercorsoFileDecompresso, Path.GetFileName(path));
                                        using (FileStream file = File.Create(path))
                                        {
                                            reader.Read(file);
                                            Esisto = true;
                                        }
                                    }



                                }

                            }



                        }
                    }
                }

            }
            catch (Exception ex)
            {

                throw ex;
            }
            return Esisto;
        }

        public static void DecomprimiFileGz(FileInfo pFileInfo)
        {
            //Rilevo lo stream dei file e decomprimo tutti i file . 
            using (FileStream StreamFile = pFileInfo.OpenRead())
            {
                //imposto il nome del file togliendo l'estenzione .gz
                string FileCorrente = pFileInfo.FullName;
                string FileOrigine = FileCorrente.Remove(FileCorrente.Length - pFileInfo.Extension.Length);

                
                using (FileStream outFile = File.Create(FileOrigine))
                {
                    using (GZipStream Decompress = new GZipStream(StreamFile,    CompressionMode.Decompress))
                    {
                       
                        byte[] buffer = new byte[4096];
                        int numRead;
                        while ((numRead = Decompress.Read(buffer, 0, buffer.Length)) != 0)
                        {
                            outFile.Write(buffer, 0, numRead);
                        }
                       
                    }
                }

            }
        }
    }
}
